/* 
 * Copyright (C) 2003 Francesco Stablum (DuskDruid)
 * <duskdruid @ inventati org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */
/*#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include "conn_t.h"
#include "ip.h"
#include "tcp.h"*/ /* to be removed in the future */
#include "myheaders.h"

#define MAX_IP_NUMBERS 65536

extern int debug_flag;
extern int resolv_flag;
extern int silent_flag;
extern int numericalports_flag;
struct cache_names_t
{
  char * name;
  u_int32_t ip;
  int has_name;
};

struct cache_names_t * cache_names=NULL;
int cache_items=0;

char * cache_ip_create(struct in_addr *addr)
{
  struct cache_names_t * cache_ptr=cache_names+cache_items;
  struct hostent * query=NULL;
  if(debug_flag)
    printf("\n*d*: cache_names:%x,cache_items:%d\n",cache_names,cache_items);
  query=(struct hostent *)gethostbyaddr((char *)addr,
					sizeof(addr),
					AF_INET);
  if(query!=NULL &&
     (char *)query->h_name)
    {
      cache_ptr->name=(char *)strdup(query->h_name);
      cache_ptr->has_name=1;
    }
  else
    {
      cache_ptr->name=inet_ntoa(*addr);
      cache_ptr->has_name=1;
    }
  if(debug_flag)
    printf("*d*: cache_ptr->name(%x)=%s\n",
	   cache_ptr->name,
	   cache_ptr->name);
  cache_ptr->ip=addr->s_addr;
  cache_items++;
  if (cache_items>=MAX_IP_NUMBERS)
    cache_recreate();
  return cache_ptr->name;
  if(!silent_flag&&query->h_name==NULL)
     printf("BAD ERROR: query->h_name==NULL\n");
  
}

int cache_create()
{
  if(debug_flag)
    printf("*d* creating cache\n");
  cache_names=(struct cache_names_t *)S_calloc(MAX_IP_NUMBERS,4);
}
int cache_delete()
{
  int count;
  if(debug_flag)
    printf("*d* deleting cache:\n");
      for(count=0;count<MAX_IP_NUMBERS;count++)
	{
	  if(debug_flag)
	    printf("*d* S_freeing [%d]cache_names(%x)->name(%x)\n",
		   count,
		   (cache_names+count),
		   (cache_names+count)->name
		   );
	  
	  S_free((cache_names+count)->name);
	}
      cache_items=0;
      if(debug_flag)
	printf("*d* S_freeing cache_names\n");
      S_free(cache_names);
}
int cache_recreate()
{
  if(debug_flag)
    printf("*d* recreating cache\n");
  cache_delete();
  cache_create();
}

char * cache_ip_existence(struct in_addr *addr)
{
  struct cache_names_t * cache_ptr=NULL;
  int count;

  if (cache_names==NULL)
    cache_create();
 
  cache_ptr=cache_names;
  for(count=0;count<cache_items;count++)
    if((cache_ptr+count)->ip==addr->s_addr)
      return (cache_ptr+count)->name;
  return NULL;
}

char * cache_gethostbyaddr(struct in_addr * addr)
{
  char * name=NULL;
  if(addr!=NULL&&addr->s_addr!=0)
    if(name=cache_ip_existence(addr))
      return name;
    else
      return cache_ip_create(addr);
  else
    if(!silent_flag)
      printf("BAD ERROR: addr->s_addr==0\n");
}

char * cache_gethostbyip(u_int32_t ip)
{
  struct in_addr * addr;
  addr->s_addr=ip;
  return cache_gethostbyaddr(addr);
}

char * cache_getnamebyaddr(struct in_addr *addr)
{
  char *name;
  if(resolv_flag)
    {
      name=(char *)cache_gethostbyaddr(addr);
	if (name!=0)
	  return name;
    }
  name=(char *)strdup(inet_ntoa(*addr));

  return name;
}
char * cache_getnamebyip(u_int32_t ip)
{
  char * name;
  struct in_addr * addr=(struct in_addr *)S_calloc(sizeof(struct in_addr),1);
  addr->s_addr=ip;
  name=(char *)cache_getnamebyaddr(addr);
  S_free(addr);
  return name;
}
char * getportname(u_int16_t port)
{
  static char *service=NULL;
  static char *s_port=NULL;
  struct servent * ptr;
  if(service)
    {
      S_free(service);
      service=NULL;
    }
  if(s_port)
    {
      S_free(s_port);
      s_port=NULL;
    }

  if(!numericalports_flag)
      if(ptr=(struct servent *)getservbyport(port, "tcp"))
	if(ptr->s_name)
	  {
	    if(debug_flag)
	      printf("*d* service name resolved: %s\n",ptr->s_name);
	    return service=(char *)strdup(ptr->s_name);
	  }
  if(debug_flag)
    printf("*d* service name NOT resolved: %d\n",ntohs(port));
  s_port=(char *)S_calloc(128,1);
  sprintf(s_port,"%d",ntohs(port));
  return s_port;
}
