/* 
 * Copyright (C) 2003 Francesco Stablum (DuskDruid)
 * <duskdruid @ inventati org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */

#include "myheaders.h"
int payload_len=0;

extern int displayheader_flag;
extern int debug_flag;
extern int hexdump_flag;
extern int hexasciidump_flag;
extern int displaydata_flag;
extern int displayraw_flag;
extern int debug_flag;
extern int displayhexnonprint_flag;
extern int writeheaders_flag;


extern int ip_trasl;
extern int tcp_trasl;
extern int data_trasl;

int packet_counter=0;
struct ip *ippacket;
struct tcphdr *tcppacket;

u_char *payload;

u_int32_t tsval=0;
u_int32_t tsecr=0;
u_char opt_octet;
  int max_segsize=0;
  int opt_lenght=0;

void got_packet (u_char *useless,
		 const struct pcap_pkthdr* hdr,
		 const u_char* packet)
{



  packet_counter++;
  if(packet==NULL)
    {
      fprintf(stderr,"Didn't grab packet\n");
      bug();
    }
  
  
      
  payload_len=hdr->len-ip_trasl;
  payload_len-=tcp_trasl;
  payload_len-=data_trasl;
      ippacket=(struct ip *)(packet+ip_trasl);
      switch(ippacket->ip_p)
	{
	case IPPROTO_TCP:
	  {
	    tcppacket=(struct tcphdr *)(packet+ip_trasl+tcp_trasl);
	    //	  printf("source:%d;
	    //	  dest:%d!!!\n",ntohs(tcppacket->source),ntohs(tcppacket->dest));
	    /*print ip addresses, ports and flags*/	    
	    if(displayheader_flag>0)
	      {
		display_header(stdout,ippacket,tcppacket);
	      }
	    
	    
	    if(debug_flag)
	      {
		printf ("*d* <%d. packet grabbed> [hdr->len:%d]\n", packet_counter,hdr->len);
		printf("*d* [seq:%u] [ack:%u]\n",ntohl(tcppacket->seq),ntohl(tcppacket->ack_seq));
		printf("*d* [data offset:%d] [window: %d]\n*d* [checksum: %u] [urgent pointer: %x]\n",
		       tcppacket->doff,
		       ntohl(tcppacket->window),
		       ntohl(tcppacket->check),
		       ntohl(tcppacket->urg_ptr)
		       );
		
		printf("*d*\n");
	      }
	    payload=(u_char *)(packet+ip_trasl+tcp_trasl+data_trasl); 
	    opt_octet=*payload;
	    if(debug_flag)
	      printf("*d* 1st option octet: %d\n",opt_octet);
	    switch (opt_octet)
	      {
	      case 0:
		{
		  payload++;
		  break;
		}
	      case 1:
		{
		  payload++;
		  if (*payload!=1)
		    {
		      if(debug_flag==1)
			printf("*d* WARNING: strange 2nd option octet: %d\n",*payload);
		    }
		  else
		    {
		      if(debug_flag==1)
			printf("*d* 2nd option octet: %d\n",*payload);
		      payload++;
		      if(debug_flag==1)
			{
			  printf("*d* 3rd option octet: %d --Timestamp kind\n",*payload);
			  if(*payload!=8)
			    printf("*d* WARNING: 3rd option octet should be 8!\n");
			}
		      payload++;
		      if(debug_flag==1)
			{
			  printf("*d* 4th option octet: %d --\n",*payload);
			  if (*payload!=10)
			    {
			      printf("*d* WARNING: 4th option octet should be 10!\n");
			    }
			}
		      
		      payload++;
		      tsval=*payload;
		      if(debug_flag==1)
			printf("*d* tsval: %d\n",tsval);
		      payload+=4;
		      tsecr=*payload;
		      if(debug_flag==1)
			printf("*d* tsecr: %d\n",tsecr);
		      payload+=4;
		    }
		  
		  break;
		}
	      case 2:
		{
		  
		  payload++;
		  opt_lenght=*payload;
		  if (debug_flag)
		    printf ("*d* 2nd option octet: %d --option lenght\n",max_segsize);
		  payload++;
		  max_segsize=(int)*payload;
		  if (debug_flag)
		    printf ("*d* 3rd option octet: %d --max seg.size\n",max_segsize);
		  payload+=opt_lenght-2;
		  
		  break;
		}
	      default:
		{
		  //	    payload++;
		  break;
		}
	      }
	    
	    
	    /* data section */
	    payload_len=hdr->len-(int)(payload-packet);/*calculate lenght of data section*/
	    verify(ippacket,tcppacket,payload,payload_len); /* verify the packet*/
	    if (debug_flag)
	      printf("*d* DATA section (%d bytes, after %d bytes of header)\n",
		     payload_len,
		     (int)(payload-packet)
		     );
	    
	    if(hexdump_flag)
	      if(hexasciidump_flag)
		display_dump(stdout,payload,payload_len,1,0);
	      else
		display_dump(stdout,payload,payload_len,0,0);
	    else
	      if(displaydata_flag>0)
		display_data(stdout,payload,payload_len,displayraw_flag,1,displayhexnonprint_flag);

	    if(writeheaders_flag)

	      {
		
	      }

	  }
	  break;
	  
	default: /* non-TCP packet */
	  {
	    if(debug_flag)
	      printf("*d* non-TCP packet caught: %s > %s\n",
		     inet_ntoa(ippacket->ip_src),
		     inet_ntoa(ippacket->ip_dst)
		     );	    
	  }
	}
}
