/* 
 * Copyright (C) 2003, 2004 Francesco Stablum (DuskDruid)
 * <duskdruid _at_ inventati _dot_ org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */


#include "myheaders.h"

#define AUTHOR "Francesco Stablum `DuskDruid' < "PACKAGE_BUGREPORT">"
#define EXAMPLEARGS "-i ppp0 -v2 \"not port 22\""
#define BUFFSIZ 16384
#define TERMS "tcpick comes with ABSOLUTELY NO WARRANTY.\n This is free software, and you are welcome to redistribute it\n under certain conditions; for details read COPYING file.\n"

int port;
char *exe;
  char *datalink=NULL;
  char *dev=NULL; /* name of the device to use */
  char *net; /* dot notation of the network address */
  char *mask; /* dot notation of the network mask */
  int ret=0; /* return code*/
  int datalinkid=0;

  char *errbuf[PCAP_ERRBUF_SIZE];
  char *filter=NULL;
struct bpf_program filter_compiled;
  bpf_u_int32 netp; /* ip */
  bpf_u_int32 maskp; /* subnet mask */
  struct in_addr addr;
  char current_option;
char *other_args=NULL;
  pcap_t *descr;
  const u_char *packet;
  u_char *curr_char;
  int curr_pos=0;
  struct pcap_pkthdr hdr;
  int ip_trasl=0;
  int tcp_trasl=0;
  int data_trasl=0;
  int verbose_flag=0;
  int debug_flag=0;
  int file_flag=0;
int maxconns_flag=0;
int displayheader_flag=0;
int displaydata_flag=0;
int mode_flag=0;
int silent_flag=0;
int maxconns=0;
int displayraw_flag=0;
int displayhex_flag=0;
int displayhexnonprint_flag=0;
int helpandquit_flag=0;
int versionandquit_flag=0;
int hexdump_flag=0;
int hexasciidump_flag=0;

int writeprintable_flag=0;
int writehexdump_flag=0;
int writehexasciidump_flag=0;
int writeraw_flag=0;
int writesilent_flag=0;
int writehexnonprint_flag=0;
int writeheaders_flag=0;
int writestatus_flag=0;
int writeoffset_flag=0;

int resolv_flag=0;
int numericalports_flag=0;

int color_flag=0;
int colortrack_flag=0;

extern void got_packet();
int usage()
{
  infocolor();
  fprintf(stderr,"\n %s is a very nice tool written using libpcap \n",PACKAGE_STRING);
  fprintf(stderr," it can sniff all tcp streams and stores them to files");
  fprintf(stderr," to show you what is happening :)\n");
  fprintf(stderr," Usage: %s [ -i interface ]\n",exe);
  fprintf(stderr,"           [ -q(uite) ]\n");
  fprintf(stderr,"           [ -v verbosity ] [ -d(ebug) ]\n");
  fprintf(stderr,"           \"tcpdump-stye rules\"\n");
  fprintf(stderr," Example: %s %s\n\n",exe,EXAMPLEARGS);
  fprintf(stderr," for a complete list of options see tcpick(1) manpage\n");
  fprintf(stderr," try `man 1 tcpick'\n");
  fprintf(stderr," to see version and license informations try `%s --version'\n",exe);
  fprintf(stderr," or read the `LICENSE' file, released with the package\n");
  resetcolor();

  exit(-1);
  
}
int bug()
{
  errcolor();
  fprintf(stderr,"Please mail to the author to submit this bug: <duskdruid@inventati.org>\n");
  exit(-1);
  resetcolor();
}

int main(int argc, char **argv) 
{

#ifdef HAVE_GETOPT_LONG
  static struct option long_options[]=
    {
      {"version",no_argument, &versionandquit_flag,1},
      {"help",no_argument, &helpandquit_flag,1},
      {"silent",no_argument, 0,'s'},
      {"show-header",no_argument, 0,'h'},
      {"interface",required_argument, 0, 'i'},
      {"show-raw",no_argument, 0, 'R'},
      {"show-hex",no_argument, 0,'H'},
      {"show-hexnonprint",no_argument,0,'U'},
      {"show-printable",no_argument,0,'P'},
      {"show-hexdump",no_argument, 0, 'x'},
      {"resolv-names",no_argument, 0, 'a'},
      {"show-hexasciidump",no_argument,0,'X'},
      {"numerical-services",no_argument,0,'n'},
      {"colors",no_argument,0,'C'},
      {0,0,0,0}
    };
#endif
  
  int option_index=0;

  if (argc==1)
    printf("important: `man 1 tcpick' explains all options available\n");
  exe=(char *)strdup(argv[0]);
#if HAVE_GETOPT_LONG
  while ((current_option=getopt_long(argc,argv,"ac:C::dhHi:m:nPRsSuUv::w::xX",long_options, &option_index))!=-1)
#else
    printf("Your system doesn't support getopt_long() function; you will be "
	   "unable to use the long options\n"
	   " i.e. `% tcpick --interface ppp0' DOESN'T WORK! \n");
  /* remember: NOT DOUBLE COLONS HERE (::)  */
  while ((current_option=getopt(argc,argv,"ac:C:dhHi:m:nPRsSuUv:w:xX"))!=-1)
#endif
    
    switch(current_option)
      {
      case 'a':
	{
	  resolv_flag=1;
	  break;
	}
      case 'c':
	{
	  if ((maxconns=atoi(optarg))==0)
	    {
	      errcolor();
	      fprintf(stderr,"%s: invalid number of maximum connections\n",optarg);	      exit(-1);
	      resetcolor();
	    }
	  maxconns_flag=1;
	  break;
	}
      case 'C':
	{
	  color_flag=1;
	  if(optarg!=NULL)
	    switch(atoi(optarg))
	      {
	      case 1:
		{
		  color_flag=1;
		  break;
		}
	      case 2:
		{
		  colortrack_flag=1;
		  break;
		}
	      default:
		{
		  fprintf(stderr,"%s: invalid color option\n",optarg);
		  exit(-1);
		}
	      }
  	  break;
	}
      case 'i':
	{
	  dev=optarg;
	  break;
	}
      case 'u': //get the first
	{
	  break;
	}
      case 'v':
	{
	  if (optarg!=NULL)
	    {
	      verbose_flag=strtol(optarg,(char **)NULL, 10);
	      if (verbose_flag <0 || verbose_flag>5)
		{
		  errcolor();
		  fprintf(stderr,"%s: invalid verbosity number\n",optarg);
		  resetcolor();
		  exit(-1);
		}
	      if (verbose_flag==0)
		silent_flag=1;
	    }
	  else
	    verbose_flag=1;
	  break;
	}
      case 'd': //debug mode
	{
	  debug_flag=1;
	  verbose_flag=5;
	}
      case 'm':
	if (optarg!=NULL)
	  if ((mode_flag=atoi(optarg))==0)
	    {
	      errcolor();
	      fprintf(stderr,"%s: invalid mode number\n",optarg);
	      resetcolor();
	      exit(-1);
	    }
	break;
      case 'x':
	{
	  hexdump_flag=1;
	  break;
	}
      case 'X':
	{
	  hexdump_flag=1;
	  hexasciidump_flag=1;
	  break;
	}
      case 'h':
	{
	  displayheader_flag=1;
	  break;
	}
      case 'H':
	{
	  displayhex_flag=1;
	  break;
	}
      case 's':
	{
	  silent_flag=1;
	  break;
	}
      case 'R':
	{
	  displayraw_flag=1;
	  break;
	}
      case 'P':
	{
	  displaydata_flag=1;
	  break;
	}
      case 'U':
	{
	  displaydata_flag=1;
	  displayhexnonprint_flag=1;
	  break;
	}
      case 'n':
	{
	  numericalports_flag=1;
	  break;
	}
      case 'w':
	{
	  if(optarg!=NULL)
	    {
	      int count;
	      for(count=0;count<strlen(optarg);count++)
		{
		  switch(*(optarg+count))
		    {
		    case 'P':
		      {
			writeprintable_flag=1;
			file_flag=1;
			writeraw_flag=0;
			break;
		      }
		    case 'x':
		      {
			writehexdump_flag=1;
			file_flag=1;
			writeraw_flag=0;
			break;
		      }
		    case 'X':
		      {
			writehexasciidump_flag=1;
			file_flag=1;
			writeraw_flag=0;
			break;
		      }
		    case 'R':
		      {
			file_flag=1;
			writeraw_flag=1;
			break;
		      }
		    case 's':
		      {
			file_flag=0;
			writesilent_flag=1;
			writeraw_flag=0;
			break;
		      }
		    case 'S':
		      {
			file_flag=1;
			writestatus_flag=1;
			break;
		      }
		    case 'U':
		      {
			writehexnonprint_flag=1;
			file_flag=1;
			writeraw_flag=0;
			break;
		      }
		    case 'h':
		      {
			file_flag=1;
			writeheaders_flag=1;
			break;
		      }
		    default:
		      {
			errcolor();
			fprintf(stderr,"Unrecognized write option: %c\n",*(optarg+count));
			resetcolor();
			break;
		      }

		    }
		}
	    }
	  else /* no -w argumens*/
	    {
	      file_flag=1;
	      writeraw_flag=1;
	    }



	  break;
	}
	//	default:
	//  printf("Unrecognized arguments: %s\n",optarg);
	
      }
  filter=argv[optind];
  /* setting the flags properly */
  if (verbose_flag>=1)
    displayheader_flag=1;
  if (verbose_flag>=2)
    displaydata_flag=1;
  if(displayraw_flag||
     displayhex_flag||
     displayhexnonprint_flag
     )
    displaydata_flag=1;
  if(versionandquit_flag)
    {
      infocolor();
      printf("%s\n",PACKAGE_STRING);
      printf(" Author: %s\n",AUTHOR);
      printf(" for other info try `man 1 tcpick', or `%s --help'\n\n",exe);
      printf(" %s\n",TERMS);
      resetcolor();
      exit(-1);
    }
  if(helpandquit_flag)
    {
      usage();
      exit(-1);
    }
  /* the code */
  if(!silent_flag)
    {
      highcolor();
      printf("Starting %s on %s\n",PACKAGE_STRING,get_actual_time());
      resetcolor();
    }
  if (getuid())
    {
      errcolor();
      fprintf(stderr,"you should be *root* to run %s\n",PACKAGE_STRING);
      resetcolor();
    }
  /* section B: making the filter working */
  if (dev==NULL)
    {
      dev=pcap_lookupdev((char*)errbuf);
    }
  if (dev==NULL)
    {
      errcolor();
      fprintf(stderr,"%s\n",errbuf);
      //      fprintf(stderr,"Remember: on GNU/Linux systems you should have *root* privileges to run %s\n",PACKAGE_STRING);
      resetcolor();
      exit(-1);
    }
  if (!silent_flag)
    {
      goodcolor();
      printf("%s: listening on %s\n",exe,dev);
      resetcolor();
    }
  
  /* ask pcap for the network address and mask of the device */
  ret=pcap_lookupnet(dev,&netp,&maskp,(char *)errbuf);
  if (ret==-1)
    {
      errcolor();
      fprintf(stderr,"%s\n",errbuf);
      resetcolor();
      usage();
    }
  
  addr.s_addr = netp;
  net=(char *)strdup(inet_ntoa(addr));
  if (net==NULL)
    {
      perror ("inet_ntoa");
      usage();
    }
  addr.s_addr=maskp;
  mask=(char *)strdup(inet_ntoa(addr));
  if (mask == NULL)
    {
      perror("inet_ntoa");
      usage();
    }

  
  /* section C: Let's GO! */
  
  descr = pcap_open_live(dev,BUFSIZ,0,-1,(char *)errbuf);
  if (descr==NULL)
    {
      exit(-1);
    }
  /* compiling the filter */
  if (filter!=NULL)
    {
      if (!silent_flag)
	highcolor();
        printf ("setting filter: \"%s\"\n",filter);
	resetcolor();
      if((pcap_compile(descr,&filter_compiled,filter,0,(int)net)==-1)&&(!silent_flag))
	{
	  errcolor();
	 fprintf(stderr,"error compiling filter \"%s\"\n",filter);
	 resetcolor();
	}
      pcap_setfilter(descr,&filter_compiled);
    }
  
  datalinkid=pcap_datalink(descr);
  datalink=(char *)datalinktoa(datalinkid);
  if(debug_flag)
    {
      printf ("*d* Using device: %s - net: %s - mask: %s - datalink: %s\n",dev,net,mask,datalink);
    }
  ip_trasl=datalinktooffset(datalinkid);
  if(debug_flag)
    {
      printf ("*d* ip header pointer offset set at: +%d\n",ip_trasl);
    }
 tcp_trasl=20;
 if(debug_flag)
   {
     printf ("*d* tcp header pointer offset (from ip header) set at: +%d\n",tcp_trasl);
   }
 data_trasl=20;
 if(debug_flag)
   {
     printf ("*d* data pointer offset (from tcp header) set at: +%d\n",data_trasl);
   }
 calloc_stack();/*allocating all the memory for the stack*/
  /* section D: the loop */
 while(1)
    {
      pcap_loop(descr,
		    -1,
		    got_packet,
		    NULL); // FIXME: warning: assignment makes pointer from integer without a cast


    }
}
      

