/*
Copyright (C) 2003  Francesco Stablum "DuskDruid"

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "myheaders.h"

extern int writeprintable_flag;
extern int writehexdump_flag;
extern int writehexasciidump_flag;
extern int writeraw_flag;
extern int writesilent_flag;
extern int writestatus_flag;
extern int writehexnonprint_flag;
extern int writeheaders_flag;
extern int writeoffset_flag;


FILE * open_file(struct conn_t * conn_ptr)
{

  char * filename;
  char * clientname=(char *)cache_getnamebyip(conn_ptr->client_ip);
  char * servername=(char *)cache_getnamebyip(conn_ptr->server_ip);
  int server_port=conn_ptr->server_port;

  filename=(char *)S_calloc(256,1);
  sprintf(filename,"client_%s",
	  clientname
	  );
  sprintf(filename,"%s_%s:%s",
	  filename,
	  servername,
	  getportname(server_port)
	  );
  conn_ptr->client_file=fopen(filename,"w");
  conn_ptr->client_filename=filename;
  
  filename=(char *)S_calloc(256,1);
  sprintf(filename,"server_%s",
	  clientname
	  );
  sprintf(filename,"%s_%s:%s",
	  filename,
	  servername,
	  getportname(server_port)
	  );
  conn_ptr->server_file=fopen(filename,"w");
  conn_ptr->server_filename=filename;

  conn_ptr->file_opened=1;
}
int write_data_choosemode(FILE * thefile,u_char * payload,int payload_len)
{
  if(!writesilent_flag)
    {
      if(writehexdump_flag)
	display_dump(thefile,payload,payload_len,0,0);
      else
	if(writehexasciidump_flag)
	  display_dump(thefile,payload,payload_len,1,0);
	else
	  if(writehexnonprint_flag)
	    display_data(thefile,payload,payload_len,0,1,1);
	  else
	    if(writeprintable_flag)
	      display_data(thefile,payload,payload_len,0,1,0);
	    else
	      if(writeraw_flag)
		display_data(thefile,payload,payload_len,1,1,0);
    }
}
int file_write(struct conn_t * conn_ptr,
	       int part /* client (1) or server (2) ? */
	       )
{ 
  int curr_pos; 
  FILE *thefile;
  u_char * data_ptr;
  int data_size;

  if(part==1)
    {
      thefile=conn_ptr->client_file;
      data_ptr=conn_ptr->client_data;
      data_size=conn_ptr->client_data_size;
    }
  else
    {
      thefile=conn_ptr->server_file;
      data_ptr=conn_ptr->server_data;
      data_size=conn_ptr->server_data_size;
    }
  //      printf("ftell(before): %d\n",ftell(conn_ptr->client_file));
  rewind(thefile);
  //      printf("ftell(after): %d\n",ftell(conn_ptr->client_file));
  
  if(writeraw_flag)
    for(curr_pos=0;curr_pos<=data_size;curr_pos++)
      fputc((int)*(data_ptr+curr_pos),thefile);   /* FIXME: is it useful?*/  
  else
    write_data_choosemode(thefile,data_ptr,data_size);


  fflush(conn_ptr->client_file);
  fflush(conn_ptr->server_file);
}


int write_banners_and_data(struct conn_t * conn_ptr, struct ip * ippacket, struct tcphdr * tcppacket,u_char * payload,int payload_len)
{
  if(writeheaders_flag
     ||
     writestatus_flag
     ||
     writeoffset_flag) 
    {
      FILE * thefile;
      if (conn_ptr->file_opened==0)
	{
	  open_file(conn_ptr);
	}
      if(writeheaders_flag)
	{
	  display_header(conn_ptr->client_file,ippacket,tcppacket);
	  display_header(conn_ptr->server_file,ippacket,tcppacket);
	}
      
      if(conn_ptr->client_ip==ippacket->ip_src.s_addr)
	thefile=conn_ptr->client_file;
      else
	thefile=conn_ptr->server_file;
      write_data_choosemode(thefile,payload,payload_len);
    }
}
